#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "comstroke.h"
#include "util.h"
#include "fps.h"

struct TCOMSTROKER_STATUS{
    /* COMݒϐ */
    double stroke_per_sec;  /* b̕ϑŌ */
    double miss_ratio;      /* Ōɂă~Xm */
    double rand_ratio;      /* ɂŌ̂Ԃ銄 */
    /* ȉ́ACOM̏ԁB */
    int last_stroke_frame;  /* ŌɑŌt[ */
    int next_stroke_frame;  /* ɑŌ\̃t[ */
    int frame_count;        /* ʎZt[ */
    SDL_keysym stroke_array[ALPHA_MAX]; /* Ō\̃L[z */
    size_t stroke_count;    /* ̔zɓĂf[^̗vfB */
    size_t input_count;     /* ŌB̔z̃CfbNXB */
    int nomiss_count;       /* ~XɑŌB~XƗɂȂB */
};

/*<---------------------------------------------------------------------->*/
static int get_rand(int n)
{
    if(!n)
        return 0;
    return rand() / (RAND_MAX / n + 1);
}
/*<---------------------------------------------------------------------->*/
COMSTROKER_STATUS *comstroke_alloc(void)
{
    COMSTROKER_STATUS *p;

    p = (COMSTROKER_STATUS *)malloc(sizeof(COMSTROKER_STATUS));
    memset(p, 0, sizeof(COMSTROKER_STATUS));
    return p;
}
/*<---------------------------------------------------------------------->*/
void comstroke_free(COMSTROKER_STATUS *p)
{
    free(p);
}
/*<---------------------------------------------------------------------->*/
/* COM̐f[^ǂݍށB */
int comstroke_load(COMSTROKER_STATUS *comstroker, const char *file)
{
    FILE *fp;
    char buf[64];

    fp = fopen(file, "r");
    if(fp == NULL){
        return -1;
    }
    memset(comstroker, 0, sizeof(COMSTROKER_STATUS));
    if(fgets(buf, sizeof buf, fp) != NULL){
        sscanf(buf, "%lf", &comstroker->stroke_per_sec);
    }
    if(fgets(buf, sizeof buf, fp) != NULL){
        sscanf(buf, "%lf", &comstroker->miss_ratio);
    }
    if(fgets(buf, sizeof buf, fp) != NULL){
        sscanf(buf, "%lf", &comstroker->rand_ratio);
    }
    fclose(fp);
    return 0;
}
/*<---------------------------------------------------------------------->*/
/* COMŌ̏֐B߂l͑ŌBkeysymsɑŌL[R[hB */
int comstroke_callback(COMSTROKER_STATUS *comstroker, const char *jp_str, SDL_keysym *keysyms, int keysym_max)
{
    ROMAN_PATTERN *romans[32];
    int roman_count;
    int roman_index;
    int stroke_frame;
    int need_next = 0;
    int miss_flag = 0;
    int ret_value = 0;
    size_t i;

    comstroker->frame_count++;

    /* ẐňꉞS[uBł1000bCOM͂Ȃ낤ƂƂŁB */
    if(comstroker->stroke_per_sec < 0.001){
        return 0;
    }

    /* ɑłL[܂ĂȂAłIĂ܂͎̑Ō肷B */
    if(!comstroker->stroke_count || comstroker->input_count == comstroker->stroke_count){
        roman_count = find_alphabet_pattern(romans, 32, jp_str);
        if(!roman_count){
            fprintf(stderr, "COM:[}p^[`̂Ђ炪ȂłBi%sj\n", jp_str);
            return -1;
        }
        /* At@xbgp^[_ɑIB */
        roman_index = get_rand(roman_count);
        /* L[z̒B */
        comstroker->stroke_count = romans[roman_index]->alphabet_length;
        /* At@xbgp^[SDL_keysym̒lɕϊăL[zɓB */
#define OUT_LOG 0
#if OUT_LOG
        printf("com=,%s,", jp_str);
#endif
        for(i=0;i<comstroker->stroke_count;i++){
            util_inchar2SDLkeysym(&comstroker->stroke_array[i], romans[roman_index]->alphabet_pattern[i]);
#if OUT_LOG
            printf("%c", romans[roman_index]->alphabet_pattern[i]);
#endif
        }
#if OUT_LOG
        printf("\n");
#endif
        comstroker->input_count = 0;
        need_next = 1;
    }
    else if(comstroker->stroke_count && comstroker->input_count < comstroker->stroke_count){
        /* ɑłL[܂ĂāAŌt[ɓBĂȂL[́B */
        if(comstroker->frame_count == comstroker->next_stroke_frame){
            /* ̊mŃ~XB */
            if(get_rand(1024) < comstroker->miss_ratio * 1024){
                miss_flag = 1;
            }
            /* ~X~m[~XŌP𒴂Ă狭IɃ~XB */
            if(!miss_flag &&
                comstroker->nomiss_count*comstroker->miss_ratio > 1.0){
                miss_flag = 1;
            }
            if(miss_flag){
                /* ~XŌB */
                keysyms[0].sym = 0;
                comstroker->nomiss_count = 0;
            }
            else{
                /* ~XłȂŌB */
                keysyms[0] = comstroker->stroke_array[comstroker->input_count];
                comstroker->input_count++;
                comstroker->nomiss_count++;
            }
            need_next = 1;
            ret_value = 1;
        }
    }

    /* ̑Ōt[߂Kv鎞́A߂B */
    if(need_next){
        /* łɂt[B */
        stroke_frame = (int)(FRAME_PER_SEC / comstroker->stroke_per_sec);
        /* t[𗐐łԂꂳB */
        comstroker->next_stroke_frame = (int)(comstroker->frame_count +
                (stroke_frame * (1.0 - comstroker->rand_ratio)) +
                get_rand((int)(stroke_frame * comstroker->rand_ratio * 2)) - 1);
        /* ɂߋ̃t[̑Ōt[ɂȂĂ͂ȂB */
        if(comstroker->next_stroke_frame <= comstroker->frame_count){
            comstroker->next_stroke_frame = comstroker->frame_count + 1;
        }
    }
    return ret_value;
}
