#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <time.h>
#include <locale.h>

#include "luautil.h"

#define FILE_LUALOG "_lualog.txt"

/*<---------------------------------------------------------------------->*/
// Lua ̒l𕶎ɂB߂l͏o͂oCgB
static int luavalue2str(lua_State *L, int i, char *str)
{
    if (lua_isstring(L, i)){
        return sprintf(str, "%s ", lua_tostring(L, i));
    }
    else if (lua_isnumber(L, i)){
        return sprintf(str, "%f ", lua_tonumber(L, i));
    }
    else{
        strcpy(str, "?");
        return 1;
    }
}
/*<---------------------------------------------------------------------->*/
// X^bNɊ܂܂ĂSĂ̒l񋓂AA𐶐B
//  bufsize 𒴂ꍇ͂ȏo͂ȂB
static int luaargs2str( lua_State *L, char *buf, int bufsize)
{
    int i,len,total=0;
    int n = lua_gettop(L);
    char str[256];

    buf[0] = '\0';
    for (i = 1; i <= n; i++){
        if (lua_istable(L, i)){
            // e[ȕꍇ͒gSĂ̒lWJB
            // e[u̒Ƀe[uĂꍇɁA̒g܂ōċAIɓWJ邱Ƃ͂ȂB
            lua_pushnil(L);
            while (lua_next(L, i) != 0) {
                // `L[L  -2A`lL  -1 ̈ʒuɂB
                len = luavalue2str(L, -1, str);
                lua_pop(L, 1);  // `lLA`L[L ͎̌JԂ̂߂Ɏc
                // ӂȂ蕶B
                if(total+len+1 <= bufsize){
                    strcat(buf,str);
                    total += len+1;
                }
            }
        }
        else{
            // XJ[^Ȃ炻̂܂܏o͂B
            len = luavalue2str(L, i, str);
            // ӂȂ蕶B
            if(total+len+1 <= bufsize){
                strcat(buf,str);
                total += len+1;
            }
        }
    }
    return 0;
}
/*<---------------------------------------------------------------------->*/
static void print_lua_log(char *fmt, ...)
{
    va_list argp;
    FILE *fp;
    time_t t;
    char tm_str[32];

    fp = fopen(FILE_LUALOG, "a");
    if(!fp)
        return;

    t = time(NULL);
    strftime(tm_str, sizeof(tm_str), "%y/%m/%d %H:%M:%S", localtime(&t));
    fprintf(fp, "%s  ", tm_str);

    va_start(argp, fmt);
    vfprintf(fp, fmt, argp);
    va_end(argp);
    fprintf(fp, "\n");
    fclose(fp);
}
/*<---------------------------------------------------------------------->*/
static int on_lua_alert(lua_State *L)
{
    if(lua_isstring(L, -1)){
        print_lua_log("%s", lua_tostring(L, -1));
    }
    return 0;
}
/*<---------------------------------------------------------------------->*/
void luautil_arg_error_log( lua_State *L, const char *funcname)
{
    lua_Debug ar;

    lua_getstack(L, 1, &ar);
    lua_getinfo(L, "l", &ar);
    print_lua_log("Warning : invalid argument for %s (Line %d)", funcname, ar.currentline);
}
/*<---------------------------------------------------------------------->*/
int luautil_init(void)
{
    FILE *fp;
    fp = fopen(FILE_LUALOG, "w");
    fclose(fp);
	setlocale(LC_ALL, "");
    return 0;
}
/*<---------------------------------------------------------------------->*/
lua_State *luautil_LoadLua(const char *lua_file)
{
    int result;
    lua_State *L;

    L = lua_open();
    lua_register(L, "_ALERT", on_lua_alert);

    luaopen_base(L);
    luaopen_table(L);

    result = lua_dofile(L, lua_file);
    if(result != 0){
        lua_close(L);
        return NULL;
    }
    return L;
}
/*<---------------------------------------------------------------------->*/
void luautil_FreeLua(lua_State *L)
{
    lua_close(L);
}
