#include <string.h>
#include "util.h"

/*<---------------------------------------------------------------------->*/
/*
 * SDL_keysym\̒lɂB
 * ̒l͕R[hAVtgƈꏏȂ0x80iE8rbgځjB
 * `̒l255ɂȂB
 * SDL_keysym256ȍ~iL[Ƃt@NVL[ĵŁA
 * ͈ꗥ255ɂȂĂ܂ƂɒӁB
 */
int util_SDLkeysym2inchar(const SDL_keysym *keysym)
{
    int ichr = 255;
    SDLKey sym;

    sym = keysym->sym;
    if(sym >= SDLK_a && sym <= SDLK_z){
        ichr = 'A' + sym - SDLK_a;
    }
    else if(sym >= SDLK_0 && sym <= SDLK_9){
        ichr = '0' + sym - SDLK_0;
    }
    else if(sym == SDLK_SPACE){
        ichr = ' ';
    }
    else if(sym == SDLK_MINUS){
        ichr = '-';
    }
    else if(sym == SDLK_CARET){
        ichr = '^';
    }
    else if(sym == SDLK_AT){
        ichr = '@';
    }
    else if(sym == SDLK_LEFTBRACKET){
        ichr = '[';
    }
    else if(sym == SDLK_SEMICOLON){
        ichr = ';';
    }
    else if(sym == SDLK_COLON){
        ichr = ':';
    }
    else if(sym == SDLK_RIGHTBRACKET){
        ichr = ']';
    }
    else if(sym == SDLK_COMMA){
        ichr = ',';
    }
    else if(sym == SDLK_PERIOD){
        ichr = '.';
    }
    else if(sym == SDLK_SLASH){
        ichr = '/';
    }
    else if(sym == SDLK_BACKSLASH){
        ichr = '\\';
    }
    if(keysym->mod & KMOD_SHIFT){
        ichr |= 0x80;
    }
    return ichr;
}
/*<---------------------------------------------------------------------->*/
/*
 * \̒lSDL_keysym ɂButil_SDLkeysym2char()̋tϊB
 * COML[łɎgB
 * `̒l sym=255, mod=KMOD_NONE=0 ɂȂB
 */
void util_inchar2SDLkeysym(SDL_keysym *keysym, int ichr)
{
    SDLKey sym = (SDLKey)255;
    int c;

    c = ichr & 0x7f;
    if(c >= 'A' && c <= 'Z'){
        sym = (SDLKey)(SDLK_a + (c - 'A'));
    }
    else if(c >= '0' && c <= '9'){
        sym = (SDLKey)(SDLK_0 + (c - '0'));
    }
    else if(c == ' '){
        sym = SDLK_SPACE;
    }
    else if(c == '-'){
        sym = SDLK_MINUS;
    }
    else if(c == '^'){
        sym = SDLK_CARET;
    }
    else if(c == '@'){
        sym = SDLK_AT;
    }
    else if(c == '['){
        sym = SDLK_LEFTBRACKET;
    }
    else if(c == ';'){
        sym = SDLK_SEMICOLON;
    }
    else if(c == ':'){
        sym = SDLK_COLON;
    }
    else if(c == ']'){
        sym = SDLK_RIGHTBRACKET;
    }
    else if(c == ','){
        sym = SDLK_COMMA;
    }
    else if(c == '.'){
        sym = SDLK_PERIOD;
    }
    else if(c == '/'){
        sym = SDLK_SLASH;
    }
    else if(c == '\\'){
        sym = SDLK_BACKSLASH;
    }
    keysym->sym = sym;
    if(sym == (SDLKey)255){
        keysym->mod = KMOD_NONE;
    }
    else{
        if(ichr & 0x80){
            /* SDL_keysym.h Ή̂ŃLXgȂ΂ȂB */
            keysym->mod = (SDLMod)KMOD_SHIFT;
        }else{
            keysym->mod = KMOD_NONE;
        }
    }
}
/*<---------------------------------------------------------------------->*/
/*
 * \̒lʏŌlɂB
 * VtgA-Z  a-z
 * VtgLA-Z  A-Z
 * Vtg0123456789  
 * VtgL 123456789   !"#$%&'()
 * ̑L[{[hłďo镶ƓB\Ȃ͈ꗥ󔒁B
 */
int util_inchar2visiblechar(int ichr)
{
    const char *numshift = " !\"#$%&'()";
    const char *other1 = "-^@[;:],./";
    const char *other2 = "=~`{+*}<>?";
    const char *p;
    int c;

    c = ichr & 0x7f;
    if(ichr & 0x80){
        /* Vtg̎ */
        if(c >= 'A' && c <= 'Z'){
            return c;
        }
        else if(c >= '0' && c <= '9'){
            return numshift[c - '0'];
        }
        else if(c == ' '){
            return ' ';
        }
        else if(c == '\\'){
            return c;
        }
        p = strchr(other1, c);
        if(p != NULL){
            return other2[p - other1];
        }
    }
    else{
        /* VtgȂ */
        if(c >= 'A' && c <= 'Z'){
            return c - 'A' + 'a';
        }
        else if(c >= '0' && c <= '9'){
            return c;
        }
        else if(c == ' '){
            return ' ';
        }
        else if(c == '\\'){
            return '|';
        }
        if(strchr(other1, c) != NULL){
            return c;
        }
    }
    return ' ';
}
